# -*- coding: utf-8 -*-
"""
Created on Wed Oct 01 00:55:51 2014

@author: kofi_otchey
"""
import math
import matplotlib.pyplot as plt
import scipy.stats

def d1(S, K, r, sigma, T):
    return (math.log( S / float(K)) + (r + sigma**2/2) * T) / (sigma * math.sqrt(T))
 
def d2(S, K, r, sigma, T):
    return d1(S, K, r, sigma, T) - (sigma*math.sqrt(T))
 
def CallOption(S, K, r, sigma, T):
    return S * scipy.stats.norm.cdf(d1(S, K, r, sigma, T)) - K * math.exp(-r * T) * scipy.stats.norm.cdf(d2(S, K, r, sigma, T))
 
def plotData(S,K,r,sigma,T):
    list_S = []
    list_plot_data_S = []
    
    if isinstance(S,tuple):
        list_S = list(S)
    elif isinstance(S,int):
        list_S.append(S)
    
    
    print "c_BS\t: [",


    for x in range(1,T):
        c_BS = []
        list_plot_data_S = []
        for s in list_S:
            c_BS.append(CallOption(s, K, r, sigma, x))
            list_plot_data_S.append(s)
            plt.plot(list_plot_data_S,c_BS,'-')
            print c_BS
    print " ]"
    

print "Enter current stock price:"
S = input()
print "Enter strike price:"
K= input()
print "Enter risk-free rate:"
r = float(input())/100
print "Enter volatility rate:"
sigma = float(input())/100
print "Enter time to maturity in days:"
T = input()
c_BS = []


print "S\tstock price :", S
print "K\tstrike price:", K
print "r\trisk-free rate:", r
print "sigma\tvolatility of the stock:", sigma
print "T\ttime to maturity:", T

plotData(S,K,r,sigma,T)
plt.xlabel("Stock Price")
plt.ylabel("Option Price")
plt.title("Black Scholes Call Model Graph")
plt.grid(True)
plt.show()