# -*- coding: utf-8 -*-
"""
Created on Wed Oct 01 00:55:51 2014

@author: kofi_otchey
"""
import math
import matplotlib.pyplot as plt
import scipy.stats


 
def d1(S, K, r, sigma, T):
    return (math.log(S / float(K)) + (r + sigma**2 / 2) * T) / (sigma * math.sqrt(T))
 
def d2(S, K, r, sigma, T):
    return d1(S, K, r, sigma, T) - (sigma*math.sqrt(T))
 
def PutOption(S, K, r, sigma, T):
    return (K * math.exp(-r * T) * scipy.stats.norm.cdf(-d2(S, K, r, sigma, T))) - (S * scipy.stats.norm.cdf(-d1(S, K, r, sigma, T)))

def plotData(S,K,r,sigma,T):
    list_S = []
    list_K = []
    list_plot_data_S = []
    list_plot_data_K = []
        
    if isinstance(S,tuple):
        list_S = list(S)
    elif isinstance(S,int):
        list_S.append(S)
    if isinstance(K,tuple):
        list_K = list(K)
    elif isinstance(K,int):
        list_K.append(K)
    
    
    for k in list_K:
        for s in list_S:
            
            
            
            list_plot_data_S.append(s)
            list_plot_data_K.append(k)
            p_BS.append(PutOption(s, k, r, sigma, T))
    plt.plot(list_plot_data_S,p_BS,'-r')
    
    

print "Enter current stock price:"
S = input()
print "Enter strike price:"
K= input()
print "Enter risk-free rate:"
r = float(input())/100
print "Enter volatility rate:"
sigma = float(input())/100
print "Enter time to maturity in days:"
T = float(input())/365
p_BS = []


print "S\tstock price :", S
print "K\tstrike price:", K
print "r\trisk-free rate:", r
print "sigma\tvolatility of the stock:", sigma
print "T\ttime to maturity in days:", T

plotData(S,K,r,sigma,T)
plt.xlabel("Stock Price")
plt.ylabel("Option Price")
plt.title("Black Scholes Put Model Graph")
plt.grid(True)

print "p_BS\t: [",
for p in p_BS:
    print p
print " ]"


plt.show()










